var app = getApp();
var utils = require("../../utils/util.js");

function inArray(arr, key, val) {
  for (let i = 0; i < arr.length; i++) {
    if (arr[i][key] === val) {
      return i;
    }
  }
  return -1;
}

//ArrayBuffer转字符串
function ab2str(arrayBuffer) {
  // var b = new Blob([u]);
  // var r = new FileReader();
  //  r.readAsText(b, 'utf-8');
  //  r.onload = function (){if(f)f.call(null,r.result)}
   let unit8Arr = new Uint8Array(arrayBuffer) ;
   let encodedString = String.fromCharCode.apply(null, unit8Arr)
  //  decodedString = decodeURIComponent(escape((encodedString)));//没有这一步中文会乱码
  //  console.log(encodedString,'字符转换');
   return encodedString

}
// ArrayBuffer转16进度字符串示例
function ab2hex(buffer) {
  var hexArr = Array.prototype.map.call(
    new Uint8Array(buffer),
    function (bit) {
      return ('00' + bit.toString(16)).slice(-2)
    }
  )
  return hexArr.join('');
}


function string2buffer(str){
  var bufView = new Uint8Array(str.length);
  for (var i = 0, strLen = str.length; i < strLen; i++) {
    bufView[i] = str.charCodeAt(i);
  }
  return bufView.buffer;
}



// 在页面中定义插屏广告
let interstitialAd = null


Page({
  /**
   * 页面的初始数据
   */
  data: {
    services:[],
    windowHeight:0,
    scrollViewHeight:0,
    isShowReadBox:false,
    recivedData:"",
    isShowWriteBox:false,
    data2Send:"",
    read_deviceId:null,
    read_serviceId:null,
    read_characteristicId:null,
    write_deviceId:null,
    write_serviceId:null,
    write_characteristicId:null
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    wx.setNavigationBarTitle({
        title:options.name?options.name:'连接蓝牙'
    })
    this.data.deviceId = options.deviceId
    this.getBLEDeviceServices(options.deviceId)
  },

  onShow:function(){
    var that = this;
    wx.getSystemInfo({
      success: function(res) {
        that.setData({
          windowHeight: res.windowHeight,
          scrollViewHeight:res.windowHeight
        });
      }
    });
  },

  /**
     * 生命周期函数--监听页面初次渲染完成
     */
  onReady: function () {
    
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {
    console.log("生命周期函数--监听页面卸载");
    wx.closeBLEConnection({
      deviceId: this.data.deviceId
    })
    wx.showToast({
      title: '连接已断开',
      icon: 'none'
    });

    this._discoveryStarted = false
  },


    //获取蓝牙低功耗设备所有服务 (service)
    getBLEDeviceServices(deviceId) {
      var that = this;
      wx.getBLEDeviceServices({
        deviceId,
        success: (res) => {
          that.setData({
            services:res.services
          })
            for (let i = 0; i < res.services.length; i++) {
              res.services[i]['expand'] = false
            }
        }
      })
    },
    //2、获取特征值
    getBLEDeviceCharacteristics(e) {
      var that = this;
      const ds = e.currentTarget.dataset
      const deviceId = this.data.deviceId
      const serviceId = ds.serviceId

      wx.getBLEDeviceCharacteristics({
        deviceId,
        serviceId,
        success: (res) => {
          console.log('getBLEDeviceCharacteristics success', res.characteristics)
          if(res.characteristics && res.characteristics.length >0){
            for(var j=0;j<res.characteristics.length;j++){
              res.characteristics[j]['newProperties'] = ''
              res.characteristics[j]['readFlag'] = false
              res.characteristics[j]['writeFlag'] = false
              for(var key in res.characteristics[j].properties){
                if(key == 'read'){
                  if(res.characteristics[j].properties[key]){
                    res.characteristics[j]['newProperties'] += 'READ'
                    res.characteristics[j]['readFlag'] = true
                  }
                }
                if(key == 'write'){
                  if(res.characteristics[j].properties[key]){
                    if(res.characteristics[j]['newProperties'] == 'READ'){
                      res.characteristics[j]['newProperties'] += ';WRITE'
                      res.characteristics[j]['writeFlag'] = true
                    }else{
                      res.characteristics[j]['newProperties'] = 'WRITE'
                      res.characteristics[j]['writeFlag'] = true
                    }
                  }
                }
              }
            }
          }
          console.log("newCharacteristics:",res.characteristics)
          //修改选中的service的expand状态
          if(that.data.services && that.data.services.length > 0){
            for(var i=0;i<that.data.services.length;i++){
              if(serviceId == that.data.services[i].uuid){
                that.data.services[i].expand = !that.data.services[i].expand
                that.data.services[i].characteristics = res.characteristics
              }
            }
            that.setData({
              services:that.data.services
            })
            console.log("newServices:",that.data.services)
          }
        },
        fail(res) {
          wx.showToast({
            title: '获取特征值失败',
            icon:'none'
          })
        }
      })
    },

    closeBLEConnection(num) {
      wx.closeBLEConnection({
        deviceId: this.data.deviceId
      })
      wx.showToast({
        title: '连接已断开',
        icon: 'none'
      });
  
      this._discoveryStarted = false
      wx.navigateTo({
        url: '../index/index',
      })
    },

    clickToRead(e){
      this.setData({
        isShowReadBox:true
      })
      this.data.isShowReadBox = true

      const ds = e.currentTarget.dataset
      this.data.read_deviceId = this.data.deviceId
      this.data.read_serviceId = ds.currentServiceId
      this.data.read_characteristicId = ds.currentCharacteristicId
    },

    clickToWrite(e){
      this.setData({
        isShowWriteBox:true
      })
      this.data.isShowWriteBox = true

      const ds = e.currentTarget.dataset
      this.data.write_deviceId = this.data.deviceId
      this.data.write_serviceId = ds.currentServiceId
      this.data.write_characteristicId = ds.currentCharacteristicId
    },

    hideReadModal(){
      this.setData({
        isShowReadBox:false,
        recivedData:"",
      })
      this.data.isShowCfgBox = false
    },

    hideWriteModal(){
      this.setData({
        isShowWriteBox:false,
        data2Send:"",
      })
      this.data.isShowCfgBox = false
      this.data.data2Send = ""
    },

    handleRead(){
      var that = this;
      //操作之前先监听，保证第一时间获取数据
      wx.onBLECharacteristicValueChange((characteristic) => {
        that.data.recivedData += ab2str(characteristic.value)
        console.log("读取到数据：",that.data.recivedData)
        this.setData({
          recivedData:that.data.recivedData
        })
        this.pageScrollToBottom()
      })

      var deviceId = this.data.read_deviceId
      var serviceId = this.data.read_serviceId
      var characteristicId = this.data.read_characteristicId
      wx.readBLECharacteristicValue({
        deviceId,
        serviceId,
        characteristicId: characteristicId,
        success: function (res) {
          
        },
        fail: function (res) {
          wx.showToast({
            title: '读取失败',
            icon:'none'
          })
        }
      })
    },

    clearRead(){
      this.setData({
        recivedData:""
      })
    },

    clearWrite(){
      this.setData({
        data2Send:""
      })
      this.data.data2Send = ""
    },

    handleWrite(){
      var that=this
      if(!this.data.data2Send){
          wx.showToast({
          title: '请输入数据',
          icon:'none'
        })
        return false
      }
      var deviceId = this.data.write_deviceId
      var serviceId = this.data.write_serviceId
      var characteristicId = this.data.write_characteristicId
      var buffer = string2buffer(this.data.data2Send)
      wx.writeBLECharacteristicValue({
        deviceId:  deviceId,
        serviceId:  serviceId,
        characteristicId: characteristicId,
        value: buffer,
        success: function (res) {
          wx.showToast({
            title: '发送成功',
            icon:"none",
            duration:1000
          })
        },
        fail: function (res) {
          wx.showToast({
            title: '发送失败',
            icon:"none",
            duration:1000
          })
        }
      })
    },

    getData2Send(e){
      this.data.data2Send = e.detail.value;
    },

    pageScrollToBottom: function() {
      var that = this;
      wx.createSelectorQuery().select('#page').boundingClientRect(function(rect) {
        if (rect){
          that.setData({
            scrollTop: rect.bottom +6000
          })
        }
      }).exec()
    },
})